
"""
    This code was generated by Codezu.     

    Changes to this file may cause incorrect behavior and will be lost if
    the code is regenerated.
"""


from mozurestsdk.mozuclient import default as default_client
from mozurestsdk.mozuurl import MozuUrl;
from mozurestsdk.urllocation import UrlLocation
from mozurestsdk.apicontext import ApiContext;

class HandlingFeeRule(object):
	def __init__(self, apiContext: ApiContext = None, dataViewMode="Live", mozuClient = None):
		if (apiContext is not None and apiContext.dataViewMode is None):
			apiContext.dataViewMode = dataViewMode;
		else:
			apiContext = ApiContext(dataViewMode = dataViewMode);
		self.client = mozuClient or default_client();
		self.client.withApiContext(apiContext);
	
	def getProductHandlingFeeRule(self,profilecode, id, responseFields = None):
		""" Retrieves the details of the specified product handling fee rule.
		
		Args:
			| profilecode (string) - The unique, user-defined code of the profile with which the product handling fee rule is associated.
			| id (string) - Unique identifier of the customer segment to retrieve.
			| responseFields (string) - Filtering syntax appended to an API call to increase or decrease the amount of data returned inside a JSON object. This parameter should only be used to retrieve data. Attempting to update data using this parameter may cause data loss.
		
		Returns:
			| HandlingFeeRule 
		
		Raises:
			| ApiException
		
		"""

		url = MozuUrl("/api/commerce/shipping/admin/profiles/{profilecode}/rules/producthandlingfees/{id}?responseFields={responseFields}", "GET", UrlLocation.TenantPod, False);
		url.formatUrl("id", id);
		url.formatUrl("profilecode", profilecode);
		url.formatUrl("responseFields", responseFields);
		self.client.withResourceUrl(url).execute();
		return self.client.result();

	
		
	def getProductHandlingFeeRules(self,profilecode, responseFields = None):
		""" Retrieves a list of product handling fee rules and their details.
		
		Args:
			| profilecode (string) - The unique, user-defined code of the profile with which the product handling fee rule is associated.
			| responseFields (string) - Filtering syntax appended to an API call to increase or decrease the amount of data returned inside a JSON object. This parameter should only be used to retrieve data. Attempting to update data using this parameter may cause data loss.
		
		Returns:
			| HandlingFeeRuleCollection 
		
		Raises:
			| ApiException
		
		"""

		url = MozuUrl("/api/commerce/shipping/admin/profiles/{profilecode}/rules/producthandlingfees?responseFields={responseFields}", "GET", UrlLocation.TenantPod, False);
		url.formatUrl("profilecode", profilecode);
		url.formatUrl("responseFields", responseFields);
		self.client.withResourceUrl(url).execute();
		return self.client.result();

	
		
	def createProductHandlingFeeRule(self,rule, profilecode, responseFields = None):
		""" Creates a new product handling fee rule.
		
		Args:
			| rule(rule) - The details of the new product handling fee rule.
			| profilecode (string) - The unique, user-defined code of the profile with which the product handling fee rule is associated.
			| responseFields (string) - Filtering syntax appended to an API call to increase or decrease the amount of data returned inside a JSON object. This parameter should only be used to retrieve data. Attempting to update data using this parameter may cause data loss.
		
		Returns:
			| HandlingFeeRule 
		
		Raises:
			| ApiException
		
		"""

		url = MozuUrl("/api/commerce/shipping/admin/profiles/{profilecode}/rules/producthandlingfees?responseFields={responseFields}", "POST", UrlLocation.TenantPod, False);
		url.formatUrl("profilecode", profilecode);
		url.formatUrl("responseFields", responseFields);
		self.client.withResourceUrl(url).withBody(rule).execute();
		return self.client.result();

	
		
	def updateProductHandlingFeeRule(self,rule, profilecode, id, responseFields = None):
		""" Updates the details of the specified product handling fee rule.
		
		Args:
			| rule(rule) - The updated details of the product handling fee rule.
			| profilecode (string) - The unique, user-defined code of the profile with which the product handling fee rule is associated.
			| id (string) - Unique identifier of the customer segment to retrieve.
			| responseFields (string) - Filtering syntax appended to an API call to increase or decrease the amount of data returned inside a JSON object. This parameter should only be used to retrieve data. Attempting to update data using this parameter may cause data loss.
		
		Returns:
			| HandlingFeeRule 
		
		Raises:
			| ApiException
		
		"""

		url = MozuUrl("/api/commerce/shipping/admin/profiles/{profilecode}/rules/producthandlingfees/{id}?responseFields={responseFields}", "PUT", UrlLocation.TenantPod, False);
		url.formatUrl("id", id);
		url.formatUrl("profilecode", profilecode);
		url.formatUrl("responseFields", responseFields);
		self.client.withResourceUrl(url).withBody(rule).execute();
		return self.client.result();

	
		
	def deleteProductHandlingFeeRule(self,profilecode, id):
		""" Deletes the specified product handling fee rule.
		
		Args:
			| profilecode (string) - The unique, user-defined code of the profile with which the product handling fee rule is associated.
			| id (string) - Unique identifier of the customer segment to retrieve.
		
		Raises:
			| ApiException
		
		"""

		url = MozuUrl("/api/commerce/shipping/admin/profiles/{profilecode}/rules/producthandlingfees/{id}", "DELETE", UrlLocation.TenantPod, False);
		url.formatUrl("id", id);
		url.formatUrl("profilecode", profilecode);
		self.client.withResourceUrl(url).execute();

	
	
	